//
if (window.com == null) window.com = {}
//
com.paragon = {}
//
com.paragon.C = {}
com.paragon.C.attr = {
    _prefix: "shdd-",
    onclick: "onclick",
    cref: "cref",
    hl: "hl",
    entry_label: "entry_label",
    spec: "spec",
}
com.paragon.C.props = {
    _prefix: "_shdd:",
    bg: "bg",
    hl: "hl",
    is_auto_scrolled_first_time: "is_auto_scrolled_first_time",
}
com.paragon.C.dom = {
    touchstart: "touchstart",
    touchend: "touchend",
    touchcancel: "touchcancel",
    touchmove: "touchmove",
    click: "click",
}
com.paragon.C.css = {
    background_color: "background-color",
}
//
com.paragon.event = {}
com.paragon.event.EventProcessor = function() {

    var touchestartElement = null;

    this.listen = function(b) {
        if (b) {
            addListeners();
        } else {
            removeListeners();
        }
    }

    function addListeners() {
        document.addEventListener(com.paragon.C.dom.touchstart, handleEvent, false);
        document.addEventListener(com.paragon.C.dom.touchend, handleEvent, false);
        document.addEventListener(com.paragon.C.dom.touchcancel, handleEvent, false);
        document.addEventListener(com.paragon.C.dom.touchmove, handleEvent, false);
        document.addEventListener(com.paragon.C.dom.click, handleEvent, false);
    }
    function removeListeners() {
        document.removeEventListener(com.paragon.C.dom.touchstart, handleEvent, false);
        document.removeEventListener(com.paragon.C.dom.touchend, handleEvent, false);
        document.removeEventListener(com.paragon.C.dom.touchcancel, handleEvent, false);
        document.removeEventListener(com.paragon.C.dom.touchmove, handleEvent, false);
        document.removeEventListener(com.paragon.C.dom.click, handleEvent, handleEvent, false);
    }
    function handleEvent(e) {
        if (touchestartElement != null) {
            highlightElement(touchestartElement, false);
            touchestartElement = null;
        }
        if (e.target == document.body || e.target == document.documentElement) return;
        var el = detectClickableElement(e.target);
        if (el == null) {
            if (e.type == com.paragon.C.dom.click)
                findShowHide(e);
            return;
        }
        if (e.type == com.paragon.C.dom.touchstart) {
            touchestartElement = el;
            highlightElement(touchestartElement, true);
        } else if (e.type == com.paragon.C.dom.click) {
            if (el.hasAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.onclick)) {
                eval(el.getAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.onclick));
            } else {
            	Android.translate(getTextContentExceptScript(el), detectSpanElement(e.target).getAttribute("class").toLowerCase());		
            }
        }
    }
    function highlightElement(el, b) {
        if (b) {
            var hasHighlight = false;
            if (el.firstElementChild != null && el.firstElementChild.hasAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.hl)) {
                hasHighlight = true;
                el.firstElementChild.removeAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.hl);
                el.firstElementChild[com.paragon.C.props._prefix + com.paragon.C.props.hl] = true;
            }
            el[com.paragon.C.props._prefix + com.paragon.C.props.bg] = el.style.getPropertyValue(com.paragon.C.css.background_color) == null ? "" : el.style.getPropertyValue(com.paragon.C.css.background_color);
            highlightElementChilds(hasHighlight ? el.firstElementChild : el, Android.color());
        } else {
            var hasHighlight = false;
            if (el.firstElementChild != null && el.firstElementChild[com.paragon.C.props._prefix + com.paragon.C.props.hl]) {
                hasHighlight = true;
                el.firstElementChild.setAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.hl, "");
                delete el.firstElementChild[com.paragon.C.props._prefix + com.paragon.C.props.hl];
            }
            highlightElementChilds(hasHighlight ? el.firstElementChild : el , el[com.paragon.C.props._prefix + com.paragon.C.props.bg]);
            delete el[com.paragon.C.props._prefix + com.paragon.C.props.bg];
       }
    }
    function highlightElementChilds(el, color) {
        if (el.firstElementChild == null) {
            el.style.setProperty(com.paragon.C.css.background_color, color, null);
        } else {
            el = el.firstElementChild;
            do {
                el.style.setProperty(com.paragon.C.css.background_color, color, null);
            } while ((el = el.nextElementSibling) != null);
        }
    }

    function detectClickableElement(el) {
        do {
            if (el.hasAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.onclick)
                || el.hasAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.cref)) return el;
        } while ((el = el.parentNode) != document.documentElement);
        return null;
    }
    function detectSpanElement(el) {
        do {
            if (el.tagName.toLowerCase() == 'span' && el.getAttribute("class") != null && !el.hasAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.spec)) return el;
        } while ((el = el.parentNode) != document.documentElement);
        return null;
    }

}
//
new com.paragon.event.EventProcessor().listen(true);
//
function replaceHideBlockHead(bodyElement, headElement) {
	if (typeof hideblockHardcodedReplace != 'undefined') {
		for (var i = 0; i < headElement.childNodes.length; i++) {
            var childnode = headElement.childNodes[i];
            if (childnode.firstChild)
                childnode = childnode.firstChild;

			for (var k in hideblockHardcodedReplace) {
				var direct = bodyElement.style.display != "none";
				var from = direct == true ? hideblockHardcodedReplace[k].from : hideblockHardcodedReplace[k].to;
				var to = direct == true ? hideblockHardcodedReplace[k].to : hideblockHardcodedReplace[k].from;
				childnode.innerHTML = childnode.innerHTML.replace(from,to);
			}
        }
	} else { console.log("hideblockHardcodedReplace undefined");}
}
function iterateHideBlocksUpdateReplacement() {
	var bodyElement = null;
	var headElement = null;
	for (var i = 1; null != (bodyElement = document.getElementById("hide-body-"+i)) &&  null != (headElement = document.getElementById("hide-head-"+i) ); i++) {
		console.log(bodyElement);
		console.log(headElement);
		replaceHideBlockHead(bodyElement,headElement);
	}
}
function MyShowHide(headId, bodyId, scrollToBlock) {
    var el = document.getElementById(bodyId);
    el.style.display = el.style.display == "none" ? "" : "none";
    if (true == scrollToBlock && el.style.display != "none")
        window.setTimeout(window.scrollTo, 100, 0, findPos(document.getElementById(headId)).y-5);

	replaceHideBlockHead(el, document.getElementById(headId));
}
function findShowHide(ev) {
	var el_node = ev.target;
	while (new String(el_node.id).indexOf('hide-head') == -1 && el_node.parentNode) {
	    el_node= el_node.parentNode;
	}
	if (new String(el_node.id).indexOf('hide-head') != -1) {
		MyShowHide(el_node.attributes['hide-head-id'].value,el_node.attributes['hide-body-id'].value,true);
	}
}

function scrollToFirstHighLight() {
    if (window.innerHeight >= contentHeight()) return;
    if (document.body[com.paragon.C.props._prefix + com.paragon.C.props.is_auto_scrolled_first_time]) return;
    document.body[com.paragon.C.props._prefix + com.paragon.C.props.is_auto_scrolled_first_time] = true;
    if (document.body.hasAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.entry_label) && document.getElementById(document.body.getAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.entry_label)) != null) {
        window.location = "#" + document.body.getAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.entry_label);
    } else {
        var el = null;
        if (document.querySelector instanceof Function) {
            el = document.querySelector("*[" + com.paragon.C.attr._prefix + com.paragon.C.attr.hl + "]");
        } else {
            var els = document.getElementsByTagName("span");
            for (var i=0; i<els.length; i++) {
                if (els[i].hasAttribute(com.paragon.C.attr._prefix + com.paragon.C.attr.hl)) {
                    el = els[i];
                    break;
                }
            }
        }
        if (el != null) {
            var y = findPos(el).y;
            window.scrollTo(0, y);
        }

    }
}

function contentHeight(){
    var body = document.body, html = document.documentElement;
    return Math.max( body.scrollHeight, body.offsetHeight, html.clientHeight, html.scrollHeight, html.offsetHeight );
}

function scrollToTop(){
	window.scrollTo(0,0);
}
function scrollToPosition(pos) {
	window.scrollTo(0,pos);
}
function findPos(obj) {
	var curleft = 0;
    var curtop = 0;
	if (obj.offsetParent) {
		curleft = obj.offsetLeft
		curtop = obj.offsetTop
		while (obj = obj.offsetParent) {
			curleft += obj.offsetLeft
			curtop += obj.offsetTop
		}
	}
	return { x: curleft, y: curtop};
}

function isSkeletonBlock(block) {
	var blockLabel = block.getAttribute("shdd-label");
	return (blockLabel == "abbr") || (blockLabel == "gram_skeleton");
}

function ShowBlocks() {
    var blocks = document.getElementsByName("hideblock");
    for (var i = 0; i < blocks.length; i++)
        blocks[i].style.display = isSkeletonBlock(blocks[i]) ? "none": "";
}

function HideBlocks() {
    var blocks = document.getElementsByName("hideblock");
    for (var i = 0; i < blocks.length; i++)
        blocks[i].style.display = isSkeletonBlock(blocks[i]) ? "" : "none";
}

function getTextContentExceptScript(element) {
    var text= [];
    for (var i= 0, n= element.childNodes.length; i<n; i++) {
        var child= element.childNodes[i];
        if (child.nodeType===1 && child.tagName.toLowerCase()!=='script')
            text.push(getTextContentExceptScript(child));
        else if (child.nodeType===3)
            text.push(child.data);
    }
    return text.join('');
}

///// JS FROM SDC /////

/////////////////////////
//
// SWITCH BLOCKS
//
/////////////////////////

function SwitchBlocks(stateVector) {
    var states = [];
    try {
        states = JSON.parse(stateVector)
    } catch(err) {
        states = undefined
    }

    var blocks = document.getElementsByName("switchblock");
    for (var i = 0; i < blocks.length; i++) {
		var managedBy = blocks[i].getAttribute("shdd-managed-by");
		if(managedBy == "1") {
			var thematic = blocks[i].getAttribute("shdd-thematic");
			var state = undefined;
			if(states != undefined)
				state = states[thematic];
			ToggleBlock(blocks[i], state);
		}
    }
	
	blocks = document.getElementsByName("switchcontrol");
	for (var i = 0; i < blocks.length; i++) {
		var thematic = blocks[i].getAttribute("shdd-thematic");
		if(Android.isSwitchControlAffectedByAppSettings(Number(thematic))) {
			var state = undefined;
			if(states != undefined)
				state = states[thematic];
			ToggleSwitchControl(blocks[i], state);
		}
	}
	
    Android.onSwitchStateChanged();
}

function ToggleBlock(block, state) {
	if (state == undefined)
		SwitchBlock(block);
	else
		RestoreSwitchState(block, state);
}

function GetSwitchStates(block) {
    var children = block.children;
    var states = [];
    for (var i = 0; i < children.length; i++)
        if (children[i].getAttribute("name") == "switchstate") {
            states.push(children[i]);
        }
    return states;
}

function RestoreSwitchState(block, currentState) {
    var states = GetSwitchStates(block);
    for (var i = 0; i < states.length; i++) {
        if (i == currentState) {
            states[i].style.display = "";
        } else {
            states[i].style.display = "none";
        }
    }
    return currentState;
}

function SwitchBlock(block) {
    var states = GetSwitchStates(block);
    var current = 0;
    for (var i = 0; i < states.length; i++) {
        if (states[i].style.display != "none") {
            current = i;
            states[i].style.display = "none";
            break;
        }
    }
    if (current == states.length - 1) {
        current = 0;
    } else {
        current += 1;
    }
    states[current].style.display = "";
    return current;
}

function OnSwitchControlPressed(element) {
	ToggleSwitchControl(element, undefined);
	Android.onSwitchStateChanged();
}

function OnRadioButtonPressed(element, onState, offState) {
	var group = element.getAttribute("shdd-radio-group");
	var blocks = document.getElementsByName("switchcontrol");
	for (i = 0; i < blocks.length; i++) {
		var g = blocks[i].getAttribute("shdd-radio-group");
		if(g == group)
			ToggleSwitchControl(blocks[i], (blocks[i] == element) ? onState : offState);
	}
	Android.onSwitchStateChanged();
}

function ToggleSwitchControl(element, state) {
    var labels = [];
	var i, j;
//	for(i = 1; i < arguments.length; i++)
//		labels[i - 1] = arguments[i];
	var children = element.children;
    for (i = 0; i < children.length; i++) {
        if (children[i].getAttribute("name") == "managedswitch") {
            labels.push(children[i].getAttribute("shdd-label"));
        }
    }

	var blocks = document.getElementsByName("switchblock");
	for (i = 0; i < blocks.length; i++) {
		var managedBy = blocks[i].getAttribute("shdd-managed-by");
        var label = blocks[i].getAttribute("shdd-label");
		for(j = 0; j < labels.length; j++)
			if((labels[j] == label) && (managedBy == "0")) {
				ToggleBlock(blocks[i], state);
				break;
			}
    }
	ToggleBlock(element, state);
}

function OnSwitchStateInfoRequested(ctx) {
    var ret = {"blocks": [], "controls": [], "context": JSON.parse(ctx)};
	
	var blocks = document.getElementsByName("switchblock");
	var i, j;
    for (i = 0; i < blocks.length; i++) {
		var managedBy = blocks[i].getAttribute("shdd-managed-by");
		if(managedBy == "1") {
			var thematic = blocks[i].getAttribute("shdd-thematic");
			for(j = 0; j < ret.blocks.length; j++)
				if(ret.blocks[j].thematic == thematic)
					break;
			
			if(j >= ret.blocks.length) {
				var states = GetSwitchStates(blocks[i]);
				var currentState = 0;
				for(j = 0; j < states.length; j++)
					if (states[j].style.display != "none") {
						currentState = j;
						break;
					}
				ret.blocks.push({"thematic": thematic, "state": currentState});
			}
		}
    }
	
	blocks = document.getElementsByName("switchcontrol");
	for (i = 0; i < blocks.length; i++) {
		var thematic = blocks[i].getAttribute("shdd-thematic");
		if(Android.isSwitchControlAffectedByAppSettings(Number(thematic))) {
			var states = GetSwitchStates(blocks[i]);
			var currentState = 0;
			for(j = 0; j < states.length; j++)
				if (states[j].style.display != "none") {
					currentState = j;
					break;
				}
			ret.controls.push({"thematic": thematic, "state": currentState});
		}
	}
	
	Android.onSwitchBlockInfoReceived(JSON.stringify(ret));
}

window.onhashchange = function() {
	rh = document.getElementById("running_heads_floating_cntnr");
	if(rh && (window.pageYOffset > 0) && ((window.innerHeight + window.pageYOffset) < document.body.offsetHeight))
		window.scrollBy(0, -rh.offsetHeight);
};


function showRecordButton(aId)
{
    var recordButton = document.getElementById("record"+aId.toString());
    recordButton.style.display = 'inline';
    var stopRecordButton = document.getElementById("stoprecord"+aId.toString());
    stopRecordButton.style.display = 'none';
    var playButton = document.getElementById("play"+aId.toString());
    playButton.style.display = 'none';
    var stopPlayButton = document.getElementById("stopplay"+aId.toString());
    stopPlayButton.style.display = 'none';
}

function showRecordStopButton(aId)
{
    var recordButton = document.getElementById("record"+aId.toString());
    recordButton.style.display = 'none';
    var stopRecordButton = document.getElementById("stoprecord"+aId.toString());
    stopRecordButton.style.display = 'inline';
    var playButton = document.getElementById("play"+aId.toString());
    playButton.style.display = 'none';
    var stopPlayButton = document.getElementById("stopplay"+aId.toString());
    stopPlayButton.style.display = 'none';
}

function showPlayButton(aId)
{
    var recordButton = document.getElementById("record"+aId.toString());
    recordButton.style.display = 'none';
    var stopRecordButton = document.getElementById("stoprecord"+aId.toString());
    stopRecordButton.style.display = 'none';
    var playButton = document.getElementById("play"+aId.toString());
    playButton.style.display = 'inline';
    var stopPlayButton = document.getElementById("stopplay"+aId.toString());
    stopPlayButton.style.display = 'none';
}

function showPlayStopButton(aId)
{
    var recordButton = document.getElementById("record"+aId.toString());
    recordButton.style.display = 'none';
    var stopRecordButton = document.getElementById("stoprecord"+aId.toString());
    stopRecordButton.style.display = 'none';
    var playButton = document.getElementById("play"+aId.toString());
    playButton.style.display = 'none';
    var stopPlayButton = document.getElementById("stopplay"+aId.toString());
    stopPlayButton.style.display = 'inline';
}

function onRecordClick(aId)
{
    showRecordStopButton(aId);

}

function onStopRecordClick(aId)
{
    showPlayButton(aId);
}


function onPlayClick(aId)
{
    showPlayStopButton(aId);
}

function onStopPlayClick(aId)
{
    showPlayButton(aId);
}

